﻿using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Crossovers {
  [Item("SizeFairCrossover", "An operator which performs subtree swapping crossover.")]
  class SymbolicDataAnalysisExpressionSizefairCrossover<T> : SubtreeCrossover, ISymbolicDataAnalysisExpressionCrossover<T> {
    [StorableConstructor]
    protected SymbolicDataAnalysisExpressionSizefairCrossover(bool deserializing) : base(deserializing) { }
    protected SymbolicDataAnalysisExpressionSizefairCrossover(SubtreeCrossover original, Cloner cloner) : base(original, cloner) { }
    public override IDeepCloneable Clone(Cloner cloner) { return new SymbolicDataAnalysisExpressionSizefairCrossover<T>(this, cloner); }

    public override bool CanChangeName {
      get { return true; }
    }

    public SymbolicDataAnalysisExpressionSizefairCrossover()
      : base() {
      SymbolicDataAnalysisEvaluationPartitionParameter.Hidden = true;
      Name = "SizeFairCrossover";
    }
  }
}
